<?php

namespace Modules\Region\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Region\Requests\Admin\RegionRequest;
use Modules\Region\Services\RegionService;
use Modules\Country\Services\CountryService;

class RegionController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/regions';
    /** View folder */
    private $viewDirectory= 'admin.regions.';
    //

    public function __construct(
        private RegionService $regionService,
        private CountryService $countryService,
    )
    {}

    /**
     * Display a listing of the regions.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('regions.head');
        $countries = $this->countryService->get([]);
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the regions.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $regions= $this->regionService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new Region.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('regions.store');
        $head= __('regions.new');
        $countries = $this->countryService->get([]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Region in storage.
     * @param RegionRequest $request
     * @return JsonResponse
     */
    public function store(RegionRequest $request) :JsonResponse
    {
        $this->regionService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('regions.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Region.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $region = $this->regionService->getItem($id);
        if (!$region)
        {
            abort(404);
        }
        $action= route('regions.update', $region->id);
        $head= __('regions.edit');
        $countries = $this->countryService->get([]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Region in storage.
     * @param RegionRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(RegionRequest $request, int $id) :JsonResponse
    {
        $region = $this->regionService->checkItem($id);
        if (!$region)
        {
            abort(404);
        }
        $this->regionService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('regions.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Region from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->regionService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('regions.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several regions by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->regionService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('regions.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified Region from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->regionService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('regions.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several regions by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->regionService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('regions.index'),
        ];
        return ResponseService::response($response);
    }
}
